
# list of tests to run
TESTS = genericvectortoolstest \
        lowrankoperatortest \
        cgsteptest \
        multigridtest \
        nulloperatortest \
        obstacletnnmgtest \
		projectedgradienttest \
        sumoperatortest

if IPOPT
TESTS += \
	mmgtest \
	quadraticipoptsolvertest
endif

# programs just to build when "make check" is used
check_PROGRAMS = $(TESTS)

noinst_HEADERS = common.hh

# collect some common flags
COMMON_CPPFLAGS = $(AM_CPPFLAGS) $(DUNEMPICPPFLAGS) -I$(top_srcdir)
COMMON_LDADD =  $(DUNE_LDFLAGS) $(DUNE_LIBS) $(DUNEMPILIBS) $(LDADD)
COMMON_LDFLAGS = $(AM_LDFLAGS) $(DUNEMPILDFLAGS) $(DUNE_LDFLAGS)

GRID_CPPFLAGS =  $(UG_CPPFLAGS) $(ALUGRID_CPPFLAGS)
GRID_LDADD =  $(UG_LDFLAGS) $(UG_LIBS) $(ALUGRID_LDFLAGS) $(ALUGRID_LIBS)
GRID_LDFLAGS =  $(UG_LDFLAGS) $(ALUGRID_LDFLAGS)

# define the programs
cgsteptest_SOURCES = cgsteptest.cc
cgsteptest_CPPFLAGS = $(COMMON_CPPFLAGS) $(GRID_CPPFLAGS)
cgsteptest_LDADD = $(COMMON_LDADD) $(GRID_LDADD)
cgsteptest_LDFLAGS = $(COMMON_LDFLAGS) $(GRID_LDFLAGS)

genericvectortoolstest_SOURCES = genericvectortoolstest.cc
genericvectortoolstest_CPPFLAGS = $(COMMON_CPPFLAGS) $(GRID_CPPFLAGS)
genericvectortoolstest_LDADD = $(COMMON_LDADD) $(GRID_LDADD)
genericvectortoolstest_LDFLAGS = $(COMMON_LDFLAGS) $(GRID_LDFLAGS)

lowrankoperatortest_SOURCES = lowrankoperatortest.cc
lowrankoperatortest_CPPFLAGS = $(COMMON_CPPFLAGS) $(GRID_CPPFLAGS)
lowrankoperatortest_LDADD = $(COMMON_LDADD) $(GRID_LDADD)
lowrankoperatortest_LDFLAGS = $(COMMON_LDFLAGS) $(GRID_LDFLAGS)

mmgtest_SOURCES = mmgtest.cc
mmgtest_CPPFLAGS = $(COMMON_CPPFLAGS) $(GRID_CPPFLAGS) $(IPOPT_CPPFLAGS)
mmgtest_LDADD = $(COMMON_LDADD) $(GRID_LDADD) $(IPOPT_LIBS)
mmgtest_LDFLAGS = $(COMMON_LDFLAGS) $(GRID_LDFLAGS) $(IPOPT_LIBS)

multigridtest_SOURCES = multigridtest.cc
multigridtest_CPPFLAGS = $(COMMON_CPPFLAGS) $(GRID_CPPFLAGS)
multigridtest_LDADD = $(COMMON_LDADD) $(GRID_LDADD)
multigridtest_LDFLAGS = $(COMMON_LDFLAGS) $(GRID_LDFLAGS)

nulloperatortest_SOURCES = nulloperatortest.cc
nulloperatortest_CPPFLAGS = $(COMMON_CPPFLAGS) $(GRID_CPPFLAGS)
nulloperatortest_LDADD = $(COMMON_LDADD) $(GRID_LDADD)
nulloperatortest_LDFLAGS = $(COMMON_LDFLAGS) $(GRID_LDFLAGS)

obstacletnnmgtest_SOURCES = obstacletnnmgtest.cc
obstacletnnmgtest_CPPFLAGS = $(COMMON_CPPFLAGS) $(GRID_CPPFLAGS)
obstacletnnmgtest_LDADD = $(COMMON_LDADD) $(GRID_LDADD)
obstacletnnmgtest_LDFLAGS = $(COMMON_LDFLAGS) $(GRID_LDFLAGS)

projectedgradienttest_SOURCES = projectedgradienttest.cc
projectedgradienttest_CPPFLAGS = $(COMMON_CPPFLAGS) $(GRID_CPPFLAGS)
projecredgradienttest_LDADD = $(COMMON_LDADD) $(GRID_LDADD)
projectedgradienttest_LDFLAGS = $(COMMON_LDFLAGS) $(GRID_LDFLAGS)

quadraticipoptsolvertest_SOURCES = quadraticipoptsolvertest.cc
quadraticipoptsolvertest_CPPFLAGS = $(COMMON_CPPFLAGS) $(IPOPT_CPPFLAGS)
quadraticipoptsolvertest_LDADD = $(COMMON_LDADD) $(IPOPT_LDFLAGS) $(IPOPT_LIBS)
quadraticipoptsolvertest_LDFLAGS = $(COMMON_LDFLAGS) $(IPOPT_LDFLAGS) $(IPOPT_LIBS)

sumoperatortest_SOURCES = sumoperatortest.cc
sumoperatortest_CPPFLAGS = $(COMMON_CPPFLAGS) $(GRID_CPPFLAGS)
sumoperatortest_LDADD = $(COMMON_LDADD) $(GRID_LDADD)
sumoperatortest_LDFLAGS = $(COMMON_LDFLAGS) $(GRID_LDFLAGS)

CLEANFILES = *.vtu *.vtp

include $(top_srcdir)/am/global-rules
